/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyBSDL.cpp   	  				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
//MyBSDL.cpp:      BSDL-.
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>

#pragma hdrstop
#include "Unit1.h"
#include "MyBSDL.h"
#include "MyStrings.h"


//---------------------------------------------------------------------------
void LoadBSDL(int LoadMode)
{   //  BSDL     
    // IDCODE_REGISTER
    // INSTRUCTION_OPCODE  ..  -   !!!

//  ImportForm->OpenDialog1->InitialDir= (Form1->Edit1->Text) + "\\Bom_files";
  Form1->OpenDialog1->InitialDir= ExtractFileDir(Application->ExeName) + "\\BSDL";
  Form1->OpenDialog1->DefaultExt = ".bsd";
  String   strFileName;


  if(LoadMode==1)
    if(Form1->OpenDialog1->Execute())
    {
     strFileName = Form1->OpenDialog1->FileName;

     Form1->Edit18->Text=strFileName;

   TStringList  *pFileList1 = new TStringList;
   TStringList  *pFileList = new TStringList;

   //   
   pFileList1->LoadFromFile(strFileName.c_str());
   Form1->RichEdit1->WordWrap=false;

   for(int items_cnt=0; items_cnt < pFileList1->Count; items_cnt++)                    //   Pin Table = 8
   {//---------------------------------------------------
    //    
    String    row_string = pFileList1->Strings[items_cnt];
    int MyStrLen = row_string.Length();   // Length returns the number of bytes in this AnsiString
    String strTmp = "";
      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString

     for(int j=1; j <MyStrLen+1; j++)
      {
       if (row_string[j] == '\t')      //   ,   
         strTmp += ' ';
       else
         strTmp += row_string[j];
       }


    pFileList->Add(strTmp);

    Form1->RichEdit1->Lines->Add(row_string);

    }


   //  
   Form1->Edit27->Text = FindChipNameInBSDL(pFileList,  //  
                                            "entity",   //    
                                            0,          //       
													                  2,          //     
													                  false,      //        
													                  "",         //     
													                  ' ');       //   

 /*
 attribute INSTRUCTION_LENGTH of EP2S60F484 : entity is 10;
 attribute INSTRUCTION_OPCODE of EP2S60F484 : entity is
  "BYPASS            (1111111111), "&amp;                //   (1111111111),   !!!!
  "EXTEST            (0000001111), "&amp;
  "SAMPLE            (0000000101), "&amp;
  "IDCODE            (0000000110), "&amp;
  "USERCODE          (0000000111), "&amp;
 */


   //  INSTRUCTION_LENGTH
   Form1->Edit26->Text = FindChipNameInBSDL(pFileList, //  
                                            "INSTRUCTION_LENGTH",     //    
                                            0,          //       
													                  2,          //     
													                  true,      //        
													                  "is",     //     
													                  ' '); //   

   //  BYPASS
   Form1->Edit19->Text = FindChipNameInBSDL(pFileList, //  
                                            "BYPASS",     //    
                                            0,          //       
													                  2,          //     
													                  true,      //        
													                  "BYPASS",     //     
													                  ' '); //   

   //  IDCODE
   Form1->Edit20->Text = FindChipNameInBSDL(pFileList, //  
                                            "IDCODE",     //    
                                            0,          //       
													                  2,          //     
													                  true,      //        
													                  "IDCODE",     //     
													                  ' '); //   


   //  USERCODE
   Form1->Edit21->Text = FindChipNameInBSDL(pFileList, //  
                                            "USERCODE",     //    
                                            0,          //       
													                  2,          //     
													                  true,      //        
													                  "USERCODE",     //     
													                  ' '); //   

   //  INSTRUCTION_CAPTURE
   Form1->Edit22->Text = FindChipNameInBSDL(pFileList, //  
                                            "INSTRUCTION_CAPTURE",     //    
                                            0,          //       
													                  2,          //     
													                  true,      //        
													                  "is",     //     
													                  ' '); //   

   //  IDCODE_REGISTER
/*
	attribute IDCODE_REGISTER of ADSP_BF533: entity is    //       !!!!
	"0010" &		-- Version
	"0010011110100101" &	
	"00001100101" &		
  "1";			

*/
   //  IDCODE_REGISTER
   //  Form1->RichEdit1->Lines->Add(FindChipIdInBsdl(pFileList));
   Form1->Edit23->Text = FindChipIdInBsdl(pFileList); //    ID  


      //  USER1
   Form1->Edit29->Text = FindChipNameInBSDL(pFileList, //  
                                            "USER1",     //    
                                            0,          //       
													                  1,          //     
													                  true,      //        
													                  "USER1",     //     
													                  ' '); //   
       //  USER1
   Form1->Edit30->Text = FindChipNameInBSDL(pFileList, //  
                                            "USER2",     //    
                                            0,          //       
													                  1,          //     
													                  true,      //        
													                  "USER2",     //     
													                  ' '); //   


   pFileList->Clear();
   pFileList1->Clear();

 delete pFileList;
 delete pFileList1;

// Form1->StatusBar1->SimpleText=("File loaded !!!");
// Form1->Caption = "   " + Form1->Edit2->Text;
 }
}
//---------------------------------------------------------------------------

String FindChipParamsInBSDL(TStringList  *pFileList, String strSubString)
{//          pFileList.
   String    strFindString;
   FindStringNumber=0;
	 for(FindStringNumber=0; FindStringNumber < pFileList->Count;)                    //   Pin Table = 8
   {//---------------------------------------------------
    //    
    String    row_string = Trim(pFileList->Strings[FindStringNumber]);
    if(IfStringExist(row_string, strSubString))     //   String strSourseString, String strSubString
		 {
      strFindString = row_string + pFileList->Strings[FindStringNumber+1] ;
			break;
		  }
     FindStringNumber++;
    }
		return(strFindString);
}
//---------------------------------------------------------------------------
String FindChipNameInBSDL(TStringList  *pFileList, //  
                          String strSubString,     //    
                          int StringDispl,         //       
													int WordNumber,          //     
													bool bWordOrNumber,      //        
													String strWordInSub,     //     
													char cDelimeter)         //   
{
   String    strFindString;
   FindStringNumber=0;
	 for(FindStringNumber=0; FindStringNumber < pFileList->Count; FindStringNumber++)                    //   Pin Table = 8
   {//---------------------------------------------------
    //    
    String    row_string = pFileList->Strings[FindStringNumber];
    String    RowStringDispl;
    int DummyStrings = 0; //    

    if(IfStringExist(row_string, strSubString)
       //   
       && ((Trim(row_string)).Pos("--") != 1))   //   String strSourseString, String strSubString
       
     {
     /*
      //   -      
      if(FindStringNumber+StringDispl>pFileList->Count)
       {
        ShowMessage("    !");
        break;
        }
      else
       {
        for(int i =0; i < StringDispl; i++)
         {
          String strTestForDummy = Trim(pFileList->Strings[FindStringNumber + StringDispl + i]);

          if(((strTestForDummy).Pos("--") == 1) || (strTestForDummy == ""))
          DummyStrings++;
          }
        }
        */

      RowStringDispl = pFileList->Strings[FindStringNumber + StringDispl/* + DummyStrings*/];
      strFindString = RowStringDispl;
    //  Form1->RichEdit1->Lines->Add("FindStringNumber - " + IntToStr(FindStringNumber));
    //  Form1->RichEdit1->Lines->Add("  - " + pFileList->Strings[FindStringNumber]);
      do
       {
        FindStringNumber++;
    //    Form1->RichEdit1->Lines->Add("FindStringNumber DO - " + IntToStr(FindStringNumber));
    //    Form1->RichEdit1->Lines->Add(" DO - " + pFileList->Strings[FindStringNumber]);
        }
        while ((Trim(pFileList->Strings[FindStringNumber + StringDispl /*+ DummyStrings*/])).Pos("--") == 1);

    //   Form1->RichEdit1->Lines->Add("  - " + pFileList->Strings[FindStringNumber]);
       strFindString += " " + pFileList->Strings[FindStringNumber + StringDispl /*+ DummyStrings*/];
			break;
		  }
    }

    String strChipNameString;

    if(!bWordOrNumber)
	   {
      strChipNameString = FindWordNN(strFindString, WordNumber, cDelimeter);
	    }
    else
	  { //     
		 int WordsNumberInString = NumberOfWordsExist(strFindString, cDelimeter);
     
		 for(int i=0; i<WordsNumberInString+1; i++)
			{
       String strTmp =  FindWordNN(strFindString, i+1, cDelimeter);
       if (strWordInSub == strTmp) //      
         {
          strChipNameString = FindWordNN(strFindString, i+2, cDelimeter);
				  break;
         } 
			 }
		 }    

		return(strChipNameString);
}
//---------------------------------------------------------------------------
String FindChipIdInBsdl(TStringList  *pFileList) //    ID  
{
 // Form1->RichEdit1->Lines->Add("************    ID   ************");

	int LineCnt = 0;
	int SemiColonCnt=0; //  
  String strFindString = "";
	String row_string, strTmp, strTmp1, strTmp2;

  strTmp  = "";
	strTmp1 = "";

 do 
  {
	  row_string = Trim(pFileList->Strings[LineCnt]);
		LineCnt++;
  } while (
           !(IfStringExist(row_string, "IDCODE_REGISTER"))
           || ((Trim(row_string.Pos("--")) == 1))
             );                                              //    "IDCODE_REGISTER",    . ...
 
 if (LineCnt < pFileList->Count)                             //      
	for(int i=LineCnt-1; i < pFileList->Count; i++)                    //   Pin Table = 8
   {//---------------------------------------------------
    //    
    strTmp2 = pFileList->Strings[i];

    if(IfStringExist(strTmp2, "--"))                         //   
       row_string =  Trim(strTmp2.SubString(1, (strTmp2.Pos("--"))-1));
    else
       row_string = Trim(strTmp2);

    strTmp1 += row_string;
    
    if(IfStringExist(row_string, ';'))
			break;
   }


for(int k=1; k < strTmp1.Length()+1; k++) //   
  {
   char cCurrChar = strTmp1[k];
        if((cCurrChar == '"' )&& (SemiColonCnt == 0))
					SemiColonCnt++;
				else
					if (((cCurrChar == '"' )&& (SemiColonCnt == 1)))
					  SemiColonCnt--;

        if((cCurrChar != '"' ) && (SemiColonCnt == 1))
					strTmp += strTmp1[k];  

	}
 // Form1->Edit23->Text = strTmp;
 // Form1->RichEdit1->Lines->Add(strTmp);   //     
 // Form1->RichEdit1->Lines->Add("************************");

return(strTmp);
}
//---------------------------------------------------------------------------
