/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyBSDL.h        				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// MyBSDL.h: contain headers ofMyBSDL functions.
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
#ifndef MyBSDL_h
#define MyBSDL_h
//-----------------------------------------------------------------------------

void LoadBSDL(int LoadMode);
int FindStringNumber;
String FindChipParamsInBSDL(TStringList  *pFileList, String strSubString);
String FindChipNameInBSDL(TStringList  *pFileList, //  
                          String strSubString,     //    
                          int StringDispl,         //       
													int WordNumber,          //     
													bool bWordOrNumber,      //        
													String strWordInSub,     //     
													char cDelimeter);        //   

String FindChipIdInBsdl(TStringList  *pFileList);
//-----------------------------------------------------------------------------
#endif
