/* ***********************************************************************
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : Unit1.h         				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <Grids.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
  TPageControl *PageControl1;
  TTabSheet *TabSheet1;
  TTabSheet *TabSheet2;
  TTabSheet *TabSheet3;
  TTabSheet *TabSheet4;
  TRichEdit *RichEdit1;
  TGroupBox *GroupBox1;
  TEdit *Edit2;
  TLabel *Label1;
  TEdit *Edit3;
  TLabel *Label2;
  TEdit *Edit4;
  TLabel *Label3;
  TEdit *Edit5;
  TLabel *Label4;
  TEdit *Edit6;
  TLabel *Label5;
  TEdit *Edit7;
  TLabel *Label6;
  TEdit *Edit8;
  TLabel *Label7;
  TEdit *Edit9;
  TLabel *Label8;
  TEdit *Edit10;
  TLabel *Label9;
  TEdit *Edit11;
  TLabel *Label10;
  TEdit *Edit12;
  TLabel *Label11;
  TEdit *Edit13;
  TLabel *Label12;
  TEdit *Edit14;
  TLabel *Label13;
  TEdit *Edit15;
  TLabel *Label14;
  TEdit *Edit16;
  TLabel *Label15;
  TEdit *Edit17;
  TLabel *Label16;
  TButton *Button4;
  TComboBox *ComboBox1;
  TButton *Button5;
  TGroupBox *GroupBox2;
  TRadioButton *RadioButton1;
  TRadioButton *RadioButton2;
  TButton *Button1;
  TToolBar *ToolBar1;
  TButton *Button8;
  TEdit *Edit18;
  TLabel *Label17;
  TGroupBox *GroupBox3;
  TGroupBox *GroupBox4;
  TEdit *Edit22;
  TGroupBox *GroupBox5;
  TLabel *Label19;
  TEdit *Edit19;
  TLabel *Label20;
  TEdit *Edit20;
  TLabel *Label21;
  TEdit *Edit21;
  TGroupBox *GroupBox6;
  TEdit *Edit23;
  TGroupBox *GroupBox7;
  TEdit *Edit26;
  TButton *Button10;
  TButton *Button11;
  TOpenDialog *OpenDialog1;
  TGroupBox *GroupBox8;
  TEdit *Edit27;
  TButton *Button13;
  TGroupBox *GroupBox11;
  TLabel *Label25;
  TLabel *Label26;
  TLabel *Label27;
  TLabel *Label28;
  TEdit *Edit29;
  TEdit *Edit30;
  TEdit *Edit31;
  TEdit *Edit32;
  TGroupBox *GroupBox12;
  TEdit *Edit33;
  TLabel *Label29;
  TEdit *Edit34;
  TLabel *Label30;
  TEdit *Edit35;
  TLabel *Label31;
  TEdit *Edit36;
  TLabel *Label32;
  TEdit *Edit37;
  TLabel *Label33;
  TEdit *Edit38;
  TLabel *Label34;
  TEdit *Edit39;
  TLabel *Label35;
  TEdit *Edit40;
  TLabel *Label36;
  TEdit *Edit41;
  TLabel *Label37;
  TEdit *Edit42;
  TLabel *Label38;
  TEdit *Edit43;
  TLabel *Label39;
  TButton *Button9;
  TButton *Button16;
  TCheckBox *CheckBox1;
  TEdit *Edit44;
  TEdit *Edit45;
  TEdit *Edit46;
  TEdit *Edit47;
  TEdit *Edit48;
  TEdit *Edit49;
  TEdit *Edit50;
  TEdit *Edit51;
  TEdit *Edit52;
  TEdit *Edit53;
  TEdit *Edit54;
  TGroupBox *GroupBox13;
  TComboBox *ComboBox3;
  TGroupBox *GroupBox14;
  TGroupBox *GroupBox15;
  TButton *Button18;
  TButton *Button19;
  TBitBtn *BitBtn12;
  TBitBtn *BitBtn13;
  TBitBtn *BitBtn14;
  TComboBox *ComboBox47;
  TButton *Button54;
  TButton *Button53;
  TButton *Button61;
  TTimer *Timer1;
  TSaveDialog *SaveDialog1;
  TStringGrid *StringGrid1;
  TLabel *Label40;
  TGroupBox *GroupBox16;
  TComboBox *ComboBox4;
  TRadioButton *RadioButton3;
  TRadioButton *RadioButton4;
  TButton *Button20;
  TTabSheet *TabSheet5;
  TGroupBox *GroupBox9;
  TButton *Button12;
  TEdit *Edit55;
  TButton *Button2;
  TEdit *Edit1;
  TComboBox *ComboBox2;
  TButton *Button3;
  TSaveDialog *SaveDialog2;
  TButton *Button14;
  TButton *Button15;
  TLabel *Label41;
  TButton *Button6;
  TLabel *Label42;
  void __fastcall Button4Click(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall Button5Click(TObject *Sender);
  void __fastcall Button1Click(TObject *Sender);
  void __fastcall Button2Click(TObject *Sender);
  void __fastcall Button8Click(TObject *Sender);
  void __fastcall ComboBox1Change(TObject *Sender);
  void __fastcall Button11Click(TObject *Sender);
  void __fastcall Button12Click(TObject *Sender);
  void __fastcall Button13Click(TObject *Sender);
  void __fastcall Button14Click(TObject *Sender);
  void __fastcall Button15Click(TObject *Sender);
  void __fastcall Button10Click(TObject *Sender);
  void __fastcall Button9Click(TObject *Sender);
  void __fastcall Button16Click(TObject *Sender);
  void __fastcall BitBtn12Click(TObject *Sender);
  void __fastcall BitBtn13Click(TObject *Sender);
  void __fastcall BitBtn14Click(TObject *Sender);
  void __fastcall Button54Click(TObject *Sender);
  void __fastcall Button53Click(TObject *Sender);
  void __fastcall Button61Click(TObject *Sender);
  void __fastcall StringGrid1Click(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall Button18Click(TObject *Sender);
  void __fastcall Button19Click(TObject *Sender);
  void __fastcall StringGrid1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
  void __fastcall Button20Click(TObject *Sender);
  void __fastcall StringGrid1DblClick(TObject *Sender);
  void __fastcall ComboBox2Change(TObject *Sender);
  void __fastcall Button3Click(TObject *Sender);
  void __fastcall Button6Click(TObject *Sender);
private:	// User declarations
  TEdit *RegEditArray[16];
   
public:		// User declarations
  __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
