/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyParPort.h      				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// MyParPort.h: contain headers of MyParPort functions.
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
#ifndef MyParPort_h
#define MyParPort_h
//-----------------------------------------------------------------------------


class MyParPort {
//	      int count;

public:

 MyParPort();
  ~MyParPort();                          // closes previously opened driver, delete allocated memory

 void WriteByteToPort(int PortAddr, char cData);
 BYTE ReadByteFromPort(int PortAddr);
 bool PortOpen (void);

 void WrData (char cData);
 void WrStatus (char cData);
 void WrControl (char cData);

 BYTE RdData (void);
 BYTE RdStatus (void);
 BYTE RdControl (void);
 };

//-----------------------------------------------------------------------------
#endif
