/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyStrings.cpp  					    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// MyStrings.cpp: contain ...... of ..... functions.
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <string>
#include <cstring.h>
#include <dstring.h>
#include <Comctrls.hpp>

//   
#include <sysdyn.h>


#include "Unit1.h"
#include "MyStrings.h"
#pragma hdrstop


//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

String AddMsbBitToString (String strMain, String strBit)
{
 String strTrimBit =Trim(strBit);
 String strTrimMain=Trim(strMain);

      if((strTrimBit=="1")||(strTrimBit=="X")) // For Xilinx OE=0
       //strTmp += Trim(strMain);
       strTrimMain += "1";
      else
       {
        if(strTrimBit=="0")
         {
          strTrimMain += "0";
          }
         else  // if error !!!
          Form1->RichEdit1->Lines->Add("if error !!! - " + strTrimBit);
        }

    //      Form1->RichEdit2->Lines->Add(strTmp);
      //  return(strTmp);
        return(strTrimMain);
}
//---------------------------------------------------------------------------


bool IfStringExistCaseSens(String strSourseString, String strSubString)      //
{
 bool bOK = false;
 int FindCLK = (UpperCase(strSourseString)).Pos(strSubString);
 if(FindCLK!=NULL)
    bOK = true;
 return bOK;
}
//-------------------------------------------------------------------------------
bool IfStringExist(String strSourseString, String strSubString)      //
{
 bool bOK = false;
 int FindCLK = strSourseString.Pos(strSubString);
 if(FindCLK!=NULL)
    bOK = true;
 return bOK;
}
//-------------------------------------------------------------------------------
bool IfWordNNExist(String strSourseString, int WordNumber, char cDelimeter)
{
    //    
 int       space_cnt = 0;
 char *ch = Trim(strSourseString).c_str();
 bool      bSpaceFlag=false;
 bool      bOK=false;
 int       WordInStringPos=0;

      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString
      int MyStrLen = StrLen(Trim(strSourseString).c_str());

      for(int j=0; j <MyStrLen; j++)

        {
         if(ch[j] == cDelimeter)
          {
           if(!bSpaceFlag)
           {
            space_cnt++;
            if(space_cnt==WordNumber)
             {
              bOK=true;
              break;
              }
            }
             bSpaceFlag=true;
           }


          if(bSpaceFlag && (ch[j] != cDelimeter))
           {
            WordInStringPos=j;
            bSpaceFlag=false;
            }
           
          }
         if((WordInStringPos<MyStrLen)&&(space_cnt+1==WordNumber))
          {
           bOK=true;
           }


  return(bOK);
}
//-------------------------------------------------------------------------------
bool IfWordNNExistAnyDelim(String strSourseString, int WordNumber) // Any
{
    //    
 int       space_cnt = 0;
 char *ch = Trim(strSourseString).c_str();
 bool      bSpaceFlag=false;
 bool      bOK=false;
 int       WordInStringPos=0;

      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString
      int MyStrLen = StrLen(Trim(strSourseString).c_str());

      for(int j=0; j <MyStrLen; j++)
        {
         if((ch[j] == ' ')||(ch[j] == '	')||(ch[j] == ';')||(ch[j] == ','))  // AnyDelim
          {
           if(!bSpaceFlag)
           {
            space_cnt++;
            if(space_cnt==WordNumber)
             {
              bOK=true;
              break;
              }
            }
             bSpaceFlag=true;
           }


          if(bSpaceFlag && ((ch[j] != ' ')&&(ch[j] != '	')&&(ch[j] != ';')&&(ch[j] != ',')))
           {
            WordInStringPos=j;
            bSpaceFlag=false;
            }
           
          }
         if((WordInStringPos<MyStrLen)&&(space_cnt+1==WordNumber))
          {
           bOK=true;
           }

  return(bOK);
}

//-------------------------------------------------------------------------------
String FindWordNN(String strSourseString, int WordNumber, char cDelimeter)
{
     //    
 int       space_cnt = 0;
 String    strWordNN = "";
 bool      bSpaceFlag=false;
 String    strPrevWordNN = "";

 String strTrimSourseString =Trim(strSourseString);
 int MyStrLen = strTrimSourseString.Length();   // Length returns the number of bytes in this AnsiString

      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString

     for(int j=1; j <MyStrLen+1; j++)
      {
          if (strTrimSourseString[j] != cDelimeter)      //   ,   
            {
             bSpaceFlag=false;
             if ((strTrimSourseString[j] >= 0x30)        //     
              && (strTrimSourseString[j] != ';'))
                   strWordNN += strTrimSourseString[j];  //      sell_string
             }
           else
           {  //    , 
             if(!bSpaceFlag)
               {
                strPrevWordNN=strWordNN;
                strWordNN="";
                space_cnt++;
                bSpaceFlag=true;
                if((space_cnt==WordNumber)) //     , 
                  break;
                }
            }
      }
     if((strWordNN !="")&&(space_cnt+1==WordNumber))
       strPrevWordNN=strWordNN;

  return(strPrevWordNN);
}
//-------------------------------------------------------------------------------
String FindWordNNAnyDelim(String strSourseString, int WordNumber)
{
    //    
 int       space_cnt = 0;
 String    strWordNN = "";
 char *ch = strSourseString.c_str();
 bool      bSpaceFlag=false;
// bool      bOK=false;
 int       WordInStringPos=0;
 String    strPrevWordNN = "";

      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString
     int MyStrLen = StrLen(strSourseString.c_str());

     for(int j=0; j <MyStrLen; j++)
      {
          if ((ch[j] == ' ')||(ch[j] == '	')||(ch[j] == ';')||(ch[j] == ','))  // AnyDelim
            {
             WordInStringPos=j+1;

             if(!bSpaceFlag)
               {
                strPrevWordNN=strWordNN;
                strWordNN="";
                space_cnt++;
                bSpaceFlag=true;
                }

             }
           else
           {
             if((space_cnt==WordNumber))
             break;

             bSpaceFlag=false;
             strWordNN += ch[j];  //      sell_string
						 }
      }
     if((WordInStringPos+1<MyStrLen)&&(space_cnt+1==WordNumber))
      strPrevWordNN=strWordNN;

  return(strPrevWordNN);
}

//---------------------------------------------------------------------------
/*
String strFindResInString(String strSourseString, char cDelimeter)
{ //  $3I1068\$3N962 R45A.2 U31A.B18  <- strSourseString
 String strTmp="";

     for(int j=1; j <(NumberOfWordsExist(strSourseString, cDelimeter))+1; j++)
      {
       String strRes=FindWordNN(strSourseString, j, cDelimeter);
    //   Form1->RichEdit4->Lines->Add(IntToStr(j) + " - words - " + strRes);
       if((IfResExist(strRes))||(IfResNNExist(strRes)))
       {
      //  Form1->RichEdit5->Lines->Add(IntToStr(j) + " - Find words - " + strRes);
      //  Form1->RichEdit5->Lines->Add(IntToStr(j) + " - New Res - " + FindResOtherSide(strRes));
        strTmp=strRes;
        break;
        }
      }
    return(strTmp);
}
*/
//-------------------------------------------------------------------------------
int NumberOfWordsExist(String strSourseString, char cDelimeter)
{
/*
    //    
 int       space_cnt = 0;
 char *ch = (Trim(strSourseString)).c_str();
 bool      bSpaceFlag=false;
// int       WordInStringPos=0;

//Form1->RichEdit1->Lines->Add(strSourseString);

      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString
      int MyStrLen = StrLen((Trim(strSourseString)).c_str());

    //  for(int j=0; j <MyStrLen-1; j++)
      for(int j=0; j <MyStrLen; j++)
        {
         //----
         if(ch[j] == cDelimeter)
          {
           if(!bSpaceFlag)
           {
            space_cnt++;
            }
             bSpaceFlag=true;
           }
          //----
          if(bSpaceFlag && (ch[j] != cDelimeter))
           {
         //   WordInStringPos=j;
            bSpaceFlag=false;
            }
          //----
          }
  return(space_cnt+1);  */
 //---------------------------------------
 //---------------------------------------
 //---------------------------------------
 //---------------------------------------
    //    
 int       space_cnt = 0;
 bool      bSpaceFlag=false;
// int       WordInStringPos=0;

//Form1->RichEdit1->Lines->Add(strSourseString);

      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString
      String strTrimSourseString =Trim(strSourseString);
      int MyStrLen = strTrimSourseString.Length();

    //  for(int j=0; j <MyStrLen-1; j++)
      for(int j=1; j <MyStrLen+1; j++)
        {
         //----
         if(strTrimSourseString[j] == cDelimeter)
          {
           if(!bSpaceFlag)
           {
            space_cnt++;
            }
             bSpaceFlag=true;
           }
          //----
          if(bSpaceFlag && (strTrimSourseString[j] != cDelimeter))
           {
         //   WordInStringPos=j;
            bSpaceFlag=false;
            }
          //----
          }
  return(space_cnt+1);
}
//-------------------------------------------------------------------------------
int NumberOfWordsExistAnyDelim(String strSourseString)
{
    //    
 int       space_cnt = 0;
 char *ch = Trim(strSourseString).c_str();
 bool      bSpaceFlag=false;
// int       WordInStringPos=0;

      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    strSourseString
      int MyStrLen = StrLen(Trim(strSourseString).c_str());

      for(int j=0; j <MyStrLen; j++)

        {
         if((ch[j] == ' ')||(ch[j] == '	')||(ch[j] == ';')||(ch[j] == ','))
          {
           if(!bSpaceFlag)
           {
            space_cnt++;
            }
             bSpaceFlag=true;
           }

          if(bSpaceFlag && (ch[j] != ' ')&&(ch[j] != '	')&&(ch[j] != ';')&&(ch[j] != ','))// ch[j] != cDelimeter
           {
         //   WordInStringPos=j;
            bSpaceFlag=false;
            }
          }
  return(space_cnt+1);
}

//-------------------------------------------------------------------------------
bool IfResNNExist(String strSourseString)      //
{
 bool bOK = false;
 int FindCLK = (UpperCase(strSourseString)).Pos("RN");
 if(FindCLK==1)
    bOK = true;
 return bOK;
}
//-----------------------------------------------------------------------------

int BitStringTetradaToHex(String strTetrada)
{
 int HexData=-1;
         if(strTetrada=="0") HexData = 0 ;
         if(strTetrada=="1") HexData = 1 ;

         if(strTetrada=="00") HexData = 0 ;
         if(strTetrada=="01") HexData = 1 ;
         if(strTetrada=="10") HexData = 2 ;
         if(strTetrada=="11") HexData = 3 ;

         if(strTetrada=="000") HexData = 0 ;
         if(strTetrada=="001") HexData = 1 ;
         if(strTetrada=="010") HexData = 2 ;
         if(strTetrada=="011") HexData = 3 ;
         if(strTetrada=="100") HexData = 4 ;
         if(strTetrada=="101") HexData = 5 ;
         if(strTetrada=="110") HexData = 6 ;
         if(strTetrada=="111") HexData = 7 ;

         if(strTetrada=="0000") HexData = 0 ;
         if(strTetrada=="0001") HexData = 1 ;
         if(strTetrada=="0010") HexData = 2 ;
         if(strTetrada=="0011") HexData = 3 ; 
         if(strTetrada=="0100") HexData = 4 ;
         if(strTetrada=="0101") HexData = 5 ;
         if(strTetrada=="0110") HexData = 6 ;
         if(strTetrada=="0111") HexData = 7 ; 
         if(strTetrada=="1000") HexData = 8 ;
         if(strTetrada=="1001") HexData = 9 ;
         if(strTetrada=="1010") HexData = 10;
         if(strTetrada=="1011") HexData = 11;
         if(strTetrada=="1100") HexData = 12;
         if(strTetrada=="1101") HexData = 13; 
         if(strTetrada=="1110") HexData = 14;
         if(strTetrada=="1111") HexData = 15;

  return(HexData);
}
//-------------------------------------------------------------------------------
int BitStringByteToHex(String strByte)
{
 int ByteHexData=0;
  String strMsbTetrada = "";
  String strLsbTetrada;
  int TmpMsb=0;
  int TmpLsb;

 if(strByte.Length()>4)
  {
   strMsbTetrada  = strByte.SubString(1,strByte.Length()-4);
   strLsbTetrada  = strByte.SubString(strByte.Length()-3,4);
   TmpMsb=BitStringTetradaToHex(strMsbTetrada);
   TmpLsb=BitStringTetradaToHex(strLsbTetrada);

  if((TmpMsb!=-1)&&(TmpLsb!=-1))
    ByteHexData= (TmpMsb<<4)| TmpLsb;
  else
    Form1->RichEdit1->Lines->Add("Error in Bit String!!! Length > 4");
   }
 else
  {
   TmpLsb=BitStringTetradaToHex(strByte);
   if(TmpLsb!=-1)
    ByteHexData= TmpLsb;
   else
    {
     Form1->RichEdit1->Lines->Add("Error in Bit String!!! Length >= 4");
     Form1->RichEdit1->Lines->Add("Error in strByte - " + strByte);
     }
  }

  return(ByteHexData);
}
//-------------------------------------------------------------------------------
String BitStringTetrada(unsigned char HexTetrada, int MyStrLen)
{
 String strTetrada;
      switch (HexTetrada)
       {
         case 0  :  strTetrada = "0000";  break;
         case 1  :  strTetrada = "0001";  break;
         case 2  :  strTetrada = "0010";  break;
         case 3  :  strTetrada = "0011";  break;
         case 4  :  strTetrada = "0100";  break;
         case 5  :  strTetrada = "0101";  break;
         case 6  :  strTetrada = "0110";  break;
         case 7  :  strTetrada = "0111";  break;
         case 8  :  strTetrada = "1000";  break;
         case 9  :  strTetrada = "1001";  break;
         case 10 :  strTetrada = "1010";  break;
         case 11 :  strTetrada = "1011";  break;
         case 12 :  strTetrada = "1100";  break;
         case 13 :  strTetrada = "1101";  break;
         case 14 :  strTetrada = "1110";  break;
         case 15 :  strTetrada = "1111";  break;
       }
   if(MyStrLen<4)
     strTetrada = strTetrada.SubString(strTetrada.Length()-MyStrLen+1,MyStrLen);

   return(strTetrada);

}

//---------------------------------------------------------------------------
String BitStringByte(unsigned char HexByte, int MyStrLen)
{
 String strBitStringByte;
 unsigned char TmpMsb=HexByte >> 4;
 unsigned char TmpLsb=HexByte & 0xF;

   if(MyStrLen>=4)
    strBitStringByte = BitStringTetrada(TmpLsb, MyStrLen);
   else
    strBitStringByte = BitStringTetrada(TmpMsb, MyStrLen-4) + BitStringTetrada(TmpLsb, 4);

 return(strBitStringByte);
}
//---------------------------------------------------------------------------
char BitStringToHex(String strBitString, DynamicArray<char> &DynArray)
{
  int ByteHexData=0;
  String strMsbTetrada = "";
  String strLsbTetrada;
	String strByteString;
  int TmpMsb=0;
  int TmpLsb;

int BytesNumber;  //    

if ((strBitString.Length()%8)==0)
 BytesNumber = (strBitString.Length()/8);
else
 BytesNumber = (strBitString.Length()/8) + 1;

// Form1->RichEdit1->Lines->Add("****************");
// Form1->RichEdit1->Lines->Add("strBitString =" + strBitString);
// Form1->RichEdit1->Lines->Add("BytesNumber =" + IntToStr(BytesNumber));

 DynArray.Length = BytesNumber;

for (int i=0; i < BytesNumber; i++)
 {

//  Form1->RichEdit1->Lines->Add("i - " + IntToStr(i));

  int Tmp = strBitString.Length();
  if((i< BytesNumber-1)
     || (((strBitString.Length()%8)==0) && (i< BytesNumber)))
   {
//    Form1->RichEdit1->Lines->Add("  =" + IntToStr(Tmp-7 - 8*i));
    strByteString = strBitString.SubString(Tmp-7 - 8*i, 8);
    }
   else
    {
//     Form1->RichEdit1->Lines->Add("  =" + IntToStr(strBitString.Length()%8));
     strByteString = strBitString.SubString(1, strBitString.Length()%8);
     }
//  Form1->RichEdit1->Lines->Add("strByteString =" + strByteString);
  //          "char"
  if(strByteString.Length()>4)
    {
     strMsbTetrada  = strByteString.SubString(1,strByteString.Length()-4);
//     Form1->RichEdit1->Lines->Add("strMsbTetrada =" + strMsbTetrada);
     strLsbTetrada  = strByteString.SubString(strByteString.Length()-3,4);
//     Form1->RichEdit1->Lines->Add("strLsbTetrada =" + strLsbTetrada);
     TmpMsb=BitStringTetradaToHex(strMsbTetrada);
     TmpLsb=BitStringTetradaToHex(strLsbTetrada);
     ByteHexData= (TmpMsb<<4)| TmpLsb;
     }
  else
   {
    TmpLsb=BitStringTetradaToHex(strByteString);
    ByteHexData= TmpLsb;
    }
 //       "char"
 // Form1->RichEdit1->Lines->Add("ByteHexData - 0x" + IntToHex(ByteHexData, 2) +", i - " + IntToStr(i));
   DynArray[i]= ByteHexData;

 }

//  return(ByteHexData);
}
//---------------------------------------------------------------------------
