/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyStrings.h      				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// MyStrings.h: contain headers of ... functions.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
#ifndef MyStrings_h
#define MyStrings_h
//-----------------------------------------------------------------------------

String AddMsbBitToString (String strMain, String strBit);

bool IfStringExist(String strSourseString, String strSubString);
bool IfWordNNExist(String strSourseString, int WordNumber, char cDelimeter);
bool IfWordNNExistAnyDelim(String strSourseString, int WordNumber);
bool IfStringExistCaseSens(String strSourseString, String strSubString);
String FindWordNN(String strSourseString, int WordNumber, char cDelimeter);
String FindWordNNAnyDelim(String strSourseString, int WordNumber);

int NumberOfWordsExist(String strSourseString, char cDelimeter);
int NumberOfWordsExistAnyDelim(String strSourseString);

String strFindResInString(String strSourseString, char cDelimeter);
bool     bFindResInString(String strSourseString, char cDelimeter);

int BitStringTetradaToHex(String strTetrada);
int BitStringByteToHex(String strByte);
String BitStringTetrada(unsigned char HexTetrada, int MyStrLen);
String BitStringByte(unsigned char HexByte, int MyStrLen);


char BitStringToHex(String strBitString, DynamicArray<char> &DynArray);

//-----------------------------------------------------------------------------
#endif
