/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : OnFormStart.cpp  				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// OnFormStart.cpp: contain headers of ..... functions.
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include "Unit1.h"
#pragma hdrstop

#include "Unit1.h"
#include "MyParPort.h"
#include "MyCable.h"
#include "CableTAP.h"
#include "MyTAP.h"
#include "SaveAndLoad.h"
#include "MyStrings.h"
#include "OnFormStart.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)


//HANDLE h;
//JTAG *jtag;

MyTAP* CableP;
TEdit *RegEditArray[16];

//---------------------------------------------------------------------------
void OnFormStart (void)
{
   RegEditArray[0]  = Form1->Edit2;
	 RegEditArray[1]  = Form1->Edit3;
	 RegEditArray[2]  = Form1->Edit4;
	 RegEditArray[3]  = Form1->Edit5;
	 RegEditArray[4]  = Form1->Edit6;
	 RegEditArray[5]  = Form1->Edit7;
	 RegEditArray[6]  = Form1->Edit8;
	 RegEditArray[7]  = Form1->Edit9;
 	 RegEditArray[8]  = Form1->Edit10;
 	 RegEditArray[9]  = Form1->Edit11;  
 	 RegEditArray[10] = Form1->Edit12;  
 	 RegEditArray[11] = Form1->Edit13;  
 	 RegEditArray[12] = Form1->Edit14;  
 	 RegEditArray[13] = Form1->Edit15;
 	 RegEditArray[14] = Form1->Edit16;
 	 RegEditArray[15] = Form1->Edit17;

   Form1->Label1->Caption  = "Name";         
	 Form1->Label2->Caption  = "TDO_MASK";      
	 Form1->Label3->Caption  = "TRST_MASK";     
	 Form1->Label4->Caption  = "TMS_MASK";      
	 Form1->Label5->Caption  = "TCK_MASK";      
	 Form1->Label6->Caption  = "TDI_MASK";      
	 Form1->Label7->Caption  = "SRST_MASK";     
	 Form1->Label8->Caption  = "OUTPUT_INVERT"; 
	 Form1->Label9->Caption  = "INPUT_INVERT";  
 	 Form1->Label10->Caption = "PORT_INIT";    
 	 Form1->Label11->Caption = "VCC_SENSE";   
 	 Form1->Label12->Caption = "PROG_MASK";   
 	 Form1->Label13->Caption = "CTRL_MASK";   
 	 Form1->Label14->Caption = "D6_MASK";     
 	 Form1->Label15->Caption = "BUSY_MASK";   
 	 Form1->Label16->Caption = "PE_MASK";

	 LoadIni();
   LoadPortParams();
   CableTypes();

  //  
  CableP = new MyTAP();
 
	if(Form1->RadioButton2->Checked==true)
	 { //      
      CableP->SetParams( Form1->Edit2->Text,
                     StrToInt(Form1->Edit3->Text),
 										 StrToInt(Form1->Edit4->Text),
 										 StrToInt(Form1->Edit5->Text),
 										 StrToInt(Form1->Edit6->Text),
 										 StrToInt(Form1->Edit7->Text),
 										 StrToInt(Form1->Edit8->Text),
 										 StrToInt(Form1->Edit9->Text),
 										 StrToInt(Form1->Edit10->Text),
 										 StrToInt(Form1->Edit11->Text),
 										 StrToInt(Form1->Edit12->Text),
 										 StrToInt(Form1->Edit13->Text),
 										 StrToInt(Form1->Edit14->Text),
 										 StrToInt(Form1->Edit15->Text),
 										 StrToInt(Form1->Edit16->Text),
 										 StrToInt(Form1->Edit17->Text));	 
	 
	 }
	 else
	 { //      
       CableP->SetParams(               Form1->Edit2->Text,
                     BitStringByteToHex(Form1->Edit3->Text),
 										 BitStringByteToHex(Form1->Edit4->Text),
 										 BitStringByteToHex(Form1->Edit5->Text),
 										 BitStringByteToHex(Form1->Edit6->Text),
 										 BitStringByteToHex(Form1->Edit7->Text),
 										 BitStringByteToHex(Form1->Edit8->Text),
 										 BitStringByteToHex(Form1->Edit9->Text),
				             BitStringByteToHex(Form1->Edit10->Text),
 										 BitStringByteToHex(Form1->Edit11->Text),
 										 BitStringByteToHex(Form1->Edit12->Text),
 										 BitStringByteToHex(Form1->Edit13->Text),
 										 BitStringByteToHex(Form1->Edit14->Text),
 										 BitStringByteToHex(Form1->Edit15->Text),
 										 BitStringByteToHex(Form1->Edit16->Text),
 										 BitStringByteToHex(Form1->Edit17->Text));

    }

  for (int J = 1; J < Form1->StringGrid1->RowCount; J++)
   Form1->StringGrid1->Cells[0][J]=IntToStr(J); //

   
  CableP->TAPInit(0,  //  char tdo
                  0,  //  char init,
                  0,  //  char trst
                  0,  // char tms
                  0,  //  char tdi
                  0,  //  char srst
                  0,  //  char tck
                  1,  //  char prog
                  0); //  char ctrl

  CableP->CheckHW();     //       *.INI !!!
  CableP->CheckPower();


  Form1->StringGrid1->Cells[0][0] = "Test #";
  Form1->StringGrid1->Cells[1][0] = "BP";
  Form1->StringGrid1->Cells[2][0] = "Scan Command";
  Form1->StringGrid1->Cells[3][0] = "Scan Addr";
  Form1->StringGrid1->Cells[4][0] = "TapDrData";
  Form1->StringGrid1->Cells[5][0] = "DataBitsLength";
  Form1->StringGrid1->Cells[6][0] = "TapEndState";
  Form1->StringGrid1->Cells[7][0] = "Comment";

  Form1->StringGrid1->ColWidths[0] = 60;
  Form1->StringGrid1->ColWidths[1] = 24;
  Form1->StringGrid1->ColWidths[2] = 86;
  Form1->StringGrid1->ColWidths[3] = 79;
  Form1->StringGrid1->ColWidths[4] = 228;
  Form1->StringGrid1->ColWidths[5] = 78;
  Form1->StringGrid1->ColWidths[6] = 89;
  Form1->StringGrid1->ColWidths[7] = 198;
 // Form1->StringGrid1->ColWidths[8] = 60;


  
}

//-----------------------------------------------------------------------------
void OnFormClose (void)
{
 SaveIni();
 delete CableP;
}
//-----------------------------------------------------------------------------
